package model

import (
	"git.chillcy.com/golang/colorway/internal/pkg/database/mongo/cache"
	"github.com/zeromicro/go-zero/core/stores/mon"
)

var _ SiteGroupMarginConfigModel = (*customSiteGroupMarginConfigModel)(nil)

type (
	// SiteGroupMarginConfigModel is an interface to be customized, add more methods here,
	// and implement the added methods in customSiteGroupMarginConfigModel.
	SiteGroupMarginConfigModel interface {
		siteGroupMarginConfigModel
		cache.Cache[SiteGroupMarginConfig]
		cache.ChangeStream[SiteGroupMarginConfig]
	}

	customSiteGroupMarginConfigModel struct {
		*defaultSiteGroupMarginConfigModel
		*cache.Base[SiteGroupMarginConfig]
	}
)

// NewSiteGroupMarginConfigModel returns a model for the mongo.
func NewSiteGroupMarginConfigModel(url, db, collection string) SiteGroupMarginConfigModel {
	conn := mon.MustNewModel(url, db, collection)
	defaultModel := newDefaultSiteGroupMarginConfigModel(conn)
	customModel := &customSiteGroupMarginConfigModel{
		defaultSiteGroupMarginConfigModel: defaultModel,
	}
	customModel.Base = cache.NewBase[SiteGroupMarginConfig](defaultModel, customModel)
	return customModel
}

func (receiver *customSiteGroupMarginConfigModel) DocumentEqual(a, b SiteGroupMarginConfig) bool {
	return a.Id.Hex() == b.Id.Hex()
}
