package model

import (
	"git.chillcy.com/golang/chillcy/pkg/slice"
	"git.chillcy.com/golang/colorway/pkg/types"
	"go.mongodb.org/mongo-driver/bson/primitive"
)

const Collection = "site_group_margin_config"

type SiteGroupMarginConfig struct {
	Id        *primitive.ObjectID `bson:"_id,omitempty"`
	Seller    types.Seller        `bson:"seller"`
	GroupName string              `bson:"groupName"`
	SiteIds   []string            `bson:"siteIds"`
	Margin    float64             `bson:"margin"`
	Memos     types.Memos         `bson:"memos"`
	Enable    bool                `bson:"enable"` // 是否启用
}

func (c *SiteGroupMarginConfig) IsMatch(site string) bool {
	if !c.Enable {
		return false
	}
	if len(c.SiteIds) > 0 && !slice.Contains(c.SiteIds, site) {
		return false
	}
	return true
}
