package model

import "go.mongodb.org/mongo-driver/mongo/options"

func PaginationOption(page, size int64) *options.FindOptions {
	if page <= 0 {
		page = 1
	}
	if size <= 0 {
		size = 10
	}
	opt := options.Find()
	skip := (page - 1) * size
	opt.SetSkip(skip).SetLimit(size)
	return opt
}

func UpsertOption() *options.UpdateOptions {
	return options.Update().SetUpsert(true)
}
