package model

import "github.com/zeromicro/go-zero/core/stores/mon"

var _ BrandDataModel = (*customBrandDataModel)(nil)

type (
	// BrandDataModel is an interface to be customized, add more methods here,
	// and implement the added methods in customBrandDataModel.
	BrandDataModel interface {
		brandDataModel
	}

	customBrandDataModel struct {
		*defaultBrandDataModel
	}
)

// NewBrandDataModel returns a model for the mongo.
func NewBrandDataModel(url, db, collection string) BrandDataModel {
	conn := mon.MustNewModel(url, db, collection)
	return &customBrandDataModel{
		defaultBrandDataModel: newDefaultBrandDataModel(conn),
	}
}
