package model

const Collection = "brand_data"

type BrandData struct {
	Id                 string                        `bson:"_id"`
	BrandName          string                        `bson:"brandName"`
	Count              int                           `bson:"count"`
	SearchWord         string                        `bson:"searchWord"`
	PriceRangeCounts   []PriceRangeCount             `bson:"priceRangeCounts"`
	ProductSellCounts  []ProductSellCount            `bson:"productSellCounts"`
	PlatformOrderCount map[string]PlatformOrderCount `bson:"platformOrderCount"` // key platform
	PlatformPayAmount  map[string]PlatformPayAmount  `bson:"platformPayAmount"`
}

type BrandDataList []BrandData

type PriceRangeCount struct {
	Min   float64 `bson:"min"`
	Max   float64 `bson:"max"`
	Count int     `bson:"count"`
}

type PlatformPayAmount struct {
	DayRange map[int]float64 `bson:"dayRange"`
}

type PlatformOrderCount struct {
	DayRange   map[int]int `bson:"dayRange"`
	OrderCount int         `json:"orderCount"`
}

type ProductSellCount struct {
	Mid   string `bson:"mid"`
	Count int    `bson:"count"`
}
