package model

import "github.com/zeromicro/go-zero/core/stores/mon"

var _ ProductModel = (*customProductModel)(nil)

type (
	// ProductModel is an interface to be customized, add more methods here,
	// and implement the added methods in customProductModel.
	ProductModel interface {
		productModel
	}

	customProductModel struct {
		*defaultProductModel
	}
)

// NewProductModel returns a model for the mongo.
func NewProductModel(url, db, collection string) ProductModel {
	conn := mon.MustNewModel(url, db, collection)
	return &customProductModel{
		defaultProductModel: newDefaultProductModel(conn),
	}
}
