package model

import (
	"git.chillcy.com/golang/colorway/internal/pkg/database/mongo/cache"
	"github.com/zeromicro/go-zero/core/stores/mon"
)

var _ SiteComboMarginConfigModel = (*customSiteComboMarginConfigModel)(nil)

type (
	// SiteComboMarginConfigModel is an interface to be customized, add more methods here,
	// and implement the added methods in customSiteComboMarginConfigModel.
	SiteComboMarginConfigModel interface {
		siteComboMarginConfigModel
		cache.Cache[SiteComboMarginConfig]
		cache.ChangeStream[SiteComboMarginConfig]
	}

	customSiteComboMarginConfigModel struct {
		*defaultSiteComboMarginConfigModel
		*cache.Base[SiteComboMarginConfig]
	}
)

// NewSiteComboMarginConfigModel returns a model for the mongo.
func NewSiteComboMarginConfigModel(url, db, collection string) SiteComboMarginConfigModel {
	conn := mon.MustNewModel(url, db, collection)
	defaultModel := newDefaultSiteComboMarginConfigModel(conn)
	customModel := &customSiteComboMarginConfigModel{
		defaultSiteComboMarginConfigModel: defaultModel,
	}
	customModel.Base = cache.NewBase[SiteComboMarginConfig](defaultModel, customModel)
	return customModel
}

func (receiver *customSiteComboMarginConfigModel) DocumentEqual(a, b SiteComboMarginConfig) bool {
	return a.Id.Hex() == b.Id.Hex()
}
