package model

import (
	"git.chillcy.com/golang/colorway/internal/pkg/database/mongo/cache"
	"github.com/zeromicro/go-zero/core/stores/mon"
)

var _ SiteFloatMarginConfigModel = (*customSiteFloatMarginConfigModel)(nil)

type (
	// SiteFloatMarginConfigModel is an interface to be customized, add more methods here,
	// and implement the added methods in customSiteFloatMarginConfigModel.
	SiteFloatMarginConfigModel interface {
		siteFloatMarginConfigModel
		cache.Cache[SiteFloatMarginConfig]
		cache.ChangeStream[SiteFloatMarginConfig]
	}

	customSiteFloatMarginConfigModel struct {
		*defaultSiteFloatMarginConfigModel
		*cache.Base[SiteFloatMarginConfig]
	}
)

// NewSiteFloatMarginConfigModel returns a model for the mongo.
func NewSiteFloatMarginConfigModel(url, db, collection string) SiteFloatMarginConfigModel {
	conn := mon.MustNewModel(url, db, collection)
	defaultModel := newDefaultSiteFloatMarginConfigModel(conn)
	customModel := &customSiteFloatMarginConfigModel{
		defaultSiteFloatMarginConfigModel: defaultModel,
	}
	customModel.Base = cache.NewBase[SiteFloatMarginConfig](defaultModel, customModel)
	return customModel
}

func (receiver *customSiteFloatMarginConfigModel) DocumentEqual(a, b SiteFloatMarginConfig) bool {
	return a.Id.Hex() == b.Id.Hex()
}
