package model

import (
	"git.chillcy.com/golang/colorway/internal/pkg/database/mongo/cache"
	"github.com/zeromicro/go-zero/core/stores/mon"
)

var _ SitePlatformPriceConfigModel = (*customSitePlatformPriceConfigModel)(nil)

type (
	// SitePlatformPriceConfigModel is an interface to be customized, add more methods here,
	// and implement the added methods in customSitePlatformPriceConfigModel.
	SitePlatformPriceConfigModel interface {
		sitePlatformPriceConfigModel
		cache.Cache[SitePlatformPriceConfig]
		cache.ChangeStream[SitePlatformPriceConfig]
	}

	customSitePlatformPriceConfigModel struct {
		*defaultSitePlatformPriceConfigModel
		*cache.Base[SitePlatformPriceConfig]
	}
)

// NewSitePlatformPriceConfigModel returns a model for the mongo.
func NewSitePlatformPriceConfigModel(url, db, collection string) SitePlatformPriceConfigModel {
	conn := mon.MustNewModel(url, db, collection)
	defaultModel := newDefaultSitePlatformPriceConfigModel(conn)
	customModel := &customSitePlatformPriceConfigModel{
		defaultSitePlatformPriceConfigModel: defaultModel,
	}
	customModel.Base = cache.NewBase[SitePlatformPriceConfig](defaultModel, customModel)
	return customModel
}

func (receiver *customSitePlatformPriceConfigModel) DocumentEqual(a, b SitePlatformPriceConfig) bool {
	return a.ID.Hex() == b.ID.Hex()
}
