package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

const Collection = "subject"

type Subject struct {
	Id        primitive.ObjectID `bson:"_id,omitempty"` // 从pc3同步过来的专题ID
	Title     string             `bson:"title"`
	PriceRate float64            `bson:"priceRate"`
	Platforms []Platform         `bson:"platforms"`
	StartAt   *time.Time         `bson:"startAt"`
	ExpiredAt *time.Time         `bson:"expiredAt"`
	Created   time.Time          `bson:"created"`
	Updated   time.Time          `bson:"updated"`
}

type Platform struct {
	Name      string     `bson:"name" `
	VoTag     string     `bson:"voTag" `
	Count     int        `bson:"count" `
	IsSync    bool       `bson:"isSync" `
	ExpiredAt *time.Time `bson:"expiredAt" `
}
