package model

import "gorm.io/gorm"

type Sku struct {
	gorm.Model
	Pc3SkuId            string  `gorm:"uniqueIndex; not null; size:24"`
	Pc3ProductId        string  `gorm:"not null; size:24"`
	ColorSpuStyleNumber string  `gorm:"index: style; size:50; not null"`
	ColorSpuColorCode   string  `gorm:"index: style; size:50"`
	SourceId            string  `gorm:"size:50; not null"`
	SiteId              string  `gorm:"size:50; not null"`
	Size                string  `gorm:"size:50; not null"`
	Stock               int     `gorm:"not null"`
	Price               float64 `gorm:"type:decimal(10,2); not null"`
	Currency            string  `gorm:"size:50; not null"`
}

type Skus []Sku
