package priceRouteAdapter

import (
	"fmt"
	math2 "git.chillcy.com/golang/chillcy/pkg/math"
	"git.chillcy.com/golang/chillcy/pkg/platform"
	"git.chillcy.com/golang/colorway/pkg/types"
	"github.com/zeromicro/go-zero/core/logx"
)

type B2BAdapter struct {
}

func NewB2BAdapter() *B2BAdapter {
	return &B2BAdapter{}
}

func (c *B2BAdapter) IsMatch(route types.Route) bool {
	return route == types.RouteBB || route == types.RouteComplex
}

func (c *B2BAdapter) GetPrice(now float64, config RoutePriceDetail, plt platform.Platform) (float64, error) {
	//minValue := now*
	//	config.Rate*
	//	config.SubjectRate + config.Freight + config.Express

	finalValue := (now*
		config.Rate*
		config.SubjectRate*
		config.Margin + config.Freight + config.Express) * config.TaxRate

	msg := fmt.Sprintf("b2bAdapter 平台:%v 计算价格: (PriceDetail.Now:%v * Rate:%v * SubjectRate:%v * Margin:%v + Freight:%v + Express:%v) * TaxRate:%v = %v",
		plt,
		now,
		config.Rate,
		config.SubjectRate,
		config.Margin,
		config.Freight,
		config.Express,
		config.TaxRate,
		finalValue,
	)
	logx.Debug(msg)

	return math2.Round(finalValue, 2), nil

}
