package priceRouteAdapter

import (
	"fmt"
	math2 "git.chillcy.com/golang/chillcy/pkg/math"
	"git.chillcy.com/golang/chillcy/pkg/platform"
	"git.chillcy.com/golang/colorway/pkg/types"
	"github.com/zeromicro/go-zero/core/logx"
	"math"
)

type B2CAdapter struct {
}

func NewB2CAdapter() *B2CAdapter {
	return &B2CAdapter{}
}

func (c *B2CAdapter) IsMatch(route types.Route) bool {
	return route == types.RouteCC || route == types.RouteBC
}

func (c *B2CAdapter) GetPrice(now float64, config RoutePriceDetail, plt platform.Platform) (float64, error) {
	//minValue := (now*
	//	config.Rate*
	//	config.SubjectRate*+config.Freight + config.Express) *
	//	config.TaxRate

	finalValue := (now*
		config.Rate*
		config.SubjectRate*
		config.Margin + config.Freight + config.Express) *
		config.TaxRate

	//finalValue = math.Max(minValue, finalValue)

	// 天猫2c 推给天猫的价 = 固定汇率算的价 * 1.005 （ 如1000 则推给 天猫 1005）
	if plt == platform.PlatformTmall2c {
		finalValue = finalValue * 1.005
	}

	// 根据平台向上取整或者向上取9
	finalValue = c.roundUpToNine(finalValue, plt)

	msg := fmt.Sprintf("b2cAdapter 平台:%v 计算价格: (PriceDetail.Now:%v * Rate:%v * SubjectRate:%v * Margin:%v + Freight:%v + Express:%v) * TaxRate:%v = %v",
		plt,
		now,
		config.Rate,
		config.SubjectRate,
		config.Margin,
		config.Freight,
		config.Express,
		config.TaxRate,
		finalValue,
	)
	logx.Debug(msg)

	return math2.Round(finalValue, 2), nil

}

func (c *B2CAdapter) roundUpToNine(value float64, pf platform.Platform) float64 {
	ceil := math.Ceil(value)
	if pf != platform.PlatformMezzanine {
		return ceil
	}
	if ceil > value && math.Mod(ceil, 10) != 9 {
		ceil += 9 - math.Mod(ceil, 10)
	}
	return ceil
}
