package priceRouteAdapter

import (
	"git.chillcy.com/golang/colorway/pkg/types"
	"github.com/pkg/errors"
)

func SelectAdapter(route types.Route) (IAdapter, error) {
	allAdapter := []IAdapter{
		NewB2CAdapter(),
		NewB2BAdapter(),
	}
	for _, adapter := range allAdapter {
		if adapter.IsMatch(route) {
			return adapter, nil
		}
	}
	return nil, errors.New("未支持的路线，无法计算价格")
}
