package priceRouteAdapter

import (
	"git.chillcy.com/golang/colorway/pkg/types"
)

type RoutePriceDetail struct {
	Route          types.Route `bson:"route"`          // 线路
	Currency       string      `bson:"currency"`       // 销售平台的币种
	OriginCurrency string      `bson:"originCurrency"` // 原始币种
	Price          float64     `bson:"price"`          // 最终价格
	Rate           float64     `bson:"rate"`           // OriginCurrency -> Currency 的汇率
	Margin         float64     `bson:"margin"`         // 加价率
	SubjectRate    float64     `bson:"subjectRate"`    // 专题系数
	Subject        string      `bson:"subjectID"`      // 绑定的专题id
	DiscountRate   float64     `bson:"discountRate"`   // 商家系数
	TotalDiscount  float64     `bson:"totalDiscount"`  // 总折扣
	TaxRate        float64     `bson:"taxRate"`        // 税率
	Freight        float64     `bson:"freight"`        // 商家运费
	Express        float64     `bson:"express"`        // 跨境费
}
