package rate

import (
	"git.chillcy.com/golang/chillcy/pkg/sdk/rate"
	"git.chillcy.com/golang/colorway/pkg/types"
)

type Rate struct {
	rateClient *rate.Client
}

func NewRate(rateClient *rate.Client) *Rate {
	return &Rate{rateClient: rateClient}
}

func (receiver *Rate) GetRate(store types.Store, from, to string) (float64, error) {
	switch store {
	case types.StoreTmall2cStore1, types.StoreJDStoreGongxiao:
		return receiver.rateClient.Sell(from, to)
	case types.StoreTmall2bHK, types.StoreTmall2bEUR, types.StoreTmall2bUS:
		return receiver.rateClient.Net(from, to)
	}
	// todo 配置店铺汇率
	return receiver.rateClient.Net(from, to)
	//return 0, fmt.Errorf("未配置店铺汇率 %s", store)
}
